------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Copyright (c) 2023 - Ognjen 'xolatile' Milan Robovic
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Xabina is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either
-- version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

with ada.text_io;

with core;

package body action is

                                             ------------------------------------------------------------------------------------------

	procedure scan is
	begin
		ada.text_io.get_immediate (signal);
	end scan;

	procedure bind (symbol : character         := core.cancel;
	                mimimi : procedure_pointer := game_idle'access) is
	begin
		list (character'pos (symbol)) := mimimi;
	end bind;

	procedure unbind (symbol : character := core.cancel) is
	begin
		list (character'pos (symbol)) := game_idle'access;
	end unbind;

	procedure game_idle is begin null;            end game_idle;
	procedure game_exit is begin active := false; end game_exit;

                                             ------------------------------------------------------------------------------------------

end action;
