------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Copyright (c) 2023 - Ognjen 'xolatile' Milan Robovic
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Xabina is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either
-- version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

with core, game, action, map, item, magic, ammunition, weapon, armour, plant, animal, monster, player;

function main return integer is

begin

                                             ------------------------------------------------------------------------------------------

	action.bind ('Q', action.game_exit'access);
	action.bind ('w', player.move_up'access);
	action.bind ('s', player.move_down'access);
	action.bind ('a', player.move_left'access);
	action.bind ('d', player.move_right'access);

	core.screen_delete;
	core.screen_offset;
	core.screen_hide_cursor;

	map.generate;
	item.generate;
	weapon.generate;

                                             ------------------------------------------------------------------------------------------

	loop
		map.render;
		item.render;
		weapon.render;
		player.render;
		core.render_buffer;
		action.scan;
		action.list (character'pos (action.signal)).all;
		exit when action.active = false;
	end loop;

                                             ------------------------------------------------------------------------------------------

	core.screen_show_cursor;

	return 0;

end main;
