------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Copyright (c) 2023 - Ognjen 'xolatile' Milan Robovic
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Xabina is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either
-- version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

with core;

package body player is

                                             ------------------------------------------------------------------------------------------

	use type core.screen_width;
	use type core.screen_height;

	procedure render is
	begin
		core.render_character ('@', core.colour.cyan, core.effect.bold, core.screen_height (data.y), core.screen_width (data.x));
	end render;

	procedure move_up is
	begin
		player.data.y := player.data.y - 1;
	end move_up;

	procedure move_down is
	begin
		player.data.y := player.data.y + 1;
	end move_down;

	procedure move_left is
	begin
		player.data.x := player.data.x - 1;
	end move_left;

	procedure move_right is
	begin
		player.data.x := player.data.x + 1;
	end move_right;

                                             ------------------------------------------------------------------------------------------

end player;
