------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Copyright (c) 2023 - Ognjen 'xolatile' Milan Robovic
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Xabina is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either
-- version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

with core;

package player is

                                             ------------------------------------------------------------------------------------------

	type variable_type is
	record
		--~x       : map_width  := 0;
		--~y       : map_height := 0;
		x       : core.screen_width  := 0;
		y       : core.screen_height := 0;
		health  : natural    := 0;
		armour  : natural    := 0;
		mana    : natural    := 0;
		stamina : natural    := 0;
	end record;

                                             ------------------------------------------------------------------------------------------

	data : variable_type;

                                             ------------------------------------------------------------------------------------------

	procedure render;
	procedure move_up;
	procedure move_down;
	procedure move_left;
	procedure move_right;

                                             ------------------------------------------------------------------------------------------

end player;
